<center><a href="readinvecs.c">Actual source code: readinvecs.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:17:10+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a><font color="#B22222">/*    Reads in PETSc vectors from a PETSc binary file into matlab</font>

<a name="line4">  4: </a><font color="#B22222">  Since this is called from Matlab it cannot be compiled with C++.</font>
<a name="line5">  5: </a><font color="#B22222">  Modified Sept 28, 2003 RFK: updated obsolete mx functions.</font>
<a name="line6">  6: </a><font color="#B22222">*/</font>


<a name="line9"> 9: </a> #include <A href="../../../../../../include/petscsys.h.html">petscsys.h</A>
<a name="line10"> 10: </a> #include <A href="../../../../../../include/petscvec.h.html">petscvec.h</A>
<a name="line11"> 11: </a><font color="#A020F0">#include </font><font color="#666666">"mex.h"</font><font color="#A020F0"></font>
<a name="line12"> 12: </a><font color="#A020F0">#include &lt;fcntl.h&gt;</font>
<a name="line13"> 13: </a><font color="#A020F0">#if defined(PETSC_HAVE_UNISTD_H)</font>
<a name="line14"> 14: </a><font color="#A020F0">#include &lt;unistd.h&gt;</font>
<a name="line15"> 15: </a><font color="#A020F0">#endif</font>
<a name="line16"> 16: </a><font color="#A020F0">#if defined (PETSC_HAVE_IO_H)</font>
<a name="line17"> 17: </a><font color="#A020F0">#include &lt;io.h&gt;</font>
<a name="line18"> 18: </a><font color="#A020F0">#endif</font>
<a name="line19"> 19: </a><font color="#A020F0">#if defined(PETSC_HAVE_STRINGS_H)</font>
<a name="line20"> 20: </a><font color="#A020F0">#include &lt;strings.h&gt;</font>
<a name="line21"> 21: </a><font color="#A020F0">#endif</font>
<a name="line22"> 22: </a><font color="#A020F0">#if defined(PETSC_HAVE_STRING_H)</font>
<a name="line23"> 23: </a><font color="#A020F0">#include &lt;string.h&gt;</font>
<a name="line24"> 24: </a><font color="#A020F0">#endif</font>

<a name="line26"> 26: </a><strong><font color="#228B22">#define PETSC_MEX_ERROR(a) {fprintf(stdout,</font><font color="#666666">"ReadInVecs %s \n"</font><font color="#228B22">,a); return -1;}</font></strong>
<a name="line27"> 27: </a><font color="#B22222">/*-----------------------------------------------------------------*/</font>
<a name="line28"> 28: </a><font color="#B22222">/*</font>
<a name="line29"> 29: </a><font color="#B22222">       Reads in a single vector</font>
<a name="line30"> 30: </a><font color="#B22222">*/</font>
<a name="line33"> 33: </a><strong><font color="#4169E1"><a name="ReadInVecs"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ReadInVecs(mxArray *plhs[],int t,int dim,int *dims)</font></strong>
<a name="line34"> 34: </a>{
<a name="line35"> 35: </a>  int          cookie = 0,M,i;
<a name="line36"> 36: </a>  mxComplexity compx = mxREAL;

<a name="line38"> 38: </a>  <font color="#B22222">/* get <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> of matrix */</font>
<a name="line39"> 39: </a>  <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/PetscBinaryRead.html#PetscBinaryRead">PetscBinaryRead</A>(t,&amp;cookie,1,PETSC_INT))   <font color="#4169E1">return</font> -1;  <font color="#B22222">/* finished reading file */</font>
<a name="line40"> 40: </a>  <font color="#4169E1">if</font> (cookie != VEC_FILE_COOKIE) PETSC_MEX_ERROR(<font color="#666666">"could not read vector cookie"</font>);
<a name="line41"> 41: </a>  <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/PetscBinaryRead.html#PetscBinaryRead">PetscBinaryRead</A>(t,&amp;M,1,PETSC_INT))        PETSC_MEX_ERROR(<font color="#666666">"reading number rows"</font>);
<a name="line42"> 42: </a>
<a name="line43"> 43: </a>  <font color="#4169E1">if</font> (dim == 1) {
<a name="line44"> 44: </a>    plhs[0]  = mxCreateDoubleMatrix(M,1,mxREAL);
<a name="line45"> 45: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (dim == 2) {
<a name="line46"> 46: </a>    <font color="#4169E1">if</font> (dims[0]*dims[1] != M) {
<a name="line47"> 47: </a>      printf(<font color="#666666">"PETSC_MEX_ERROR: m %d * n %d != M %d\n"</font>,dims[0],dims[1],M);
<a name="line48"> 48: </a>      <font color="#4169E1">return</font> -1;
<a name="line49"> 49: </a>    }
<a name="line50"> 50: </a>    plhs[0]  = mxCreateDoubleMatrix(dims[0],dims[1],mxREAL);
<a name="line51"> 51: </a>  } <font color="#4169E1">else</font> {
<a name="line52"> 52: </a>    plhs[0] = mxCreateNumericArray(dim,dims,mxDOUBLE_CLASS,mxREAL);
<a name="line53"> 53: </a>  }

<a name="line55"> 55: </a>  <font color="#B22222">/* read in matrix */</font>
<a name="line56"> 56: </a>  <font color="#4169E1">if</font> (compx == mxREAL) { <font color="#B22222">/* real */</font>
<a name="line57"> 57: </a>    <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/PetscBinaryRead.html#PetscBinaryRead">PetscBinaryRead</A>(t,mxGetPr(plhs[0]),M,PETSC_DOUBLE)) PETSC_MEX_ERROR(<font color="#666666">"read dense matrix"</font>);
<a name="line58"> 58: </a>  } <font color="#4169E1">else</font> { <font color="#B22222">/* complex, currently not used */</font>
<a name="line59"> 59: </a>    <font color="#4169E1">for</font> (i=0; i&lt;M; i++) {
<a name="line60"> 60: </a>      <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/PetscBinaryRead.html#PetscBinaryRead">PetscBinaryRead</A>(t,mxGetPr(plhs[0])+i,1,PETSC_DOUBLE)) PETSC_MEX_ERROR(<font color="#666666">"read dense matrix"</font>);
<a name="line61"> 61: </a>      <font color="#4169E1">if</font> (<A href="../../../../../../docs/manualpages/Sys/PetscBinaryRead.html#PetscBinaryRead">PetscBinaryRead</A>(t,mxGetPi(plhs[0])+i,1,PETSC_DOUBLE)) PETSC_MEX_ERROR(<font color="#666666">"read dense matrix"</font>);
<a name="line62"> 62: </a>    }
<a name="line63"> 63: </a>  }
<a name="line64"> 64: </a>  <font color="#4169E1">return</font> 0;
<a name="line65"> 65: </a>}

<a name="line67"> 67: </a><strong><font color="#228B22">#undef PETSC_MEX_ERROR</font></strong>
<a name="line68"> 68: </a><strong><font color="#228B22">#define PETSC_MEX_ERROR(a) {fprintf(stdout,</font><font color="#666666">"ReadInVecs %s \n"</font><font color="#228B22">,a); return;}</font></strong>
<a name="line69"> 69: </a><font color="#B22222">/*-----------------------------------------------------------------*/</font>

<a name="line73"> 73: </a><strong><font color="#4169E1"><a name="mexFunction"></a>void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])</font></strong>
<a name="line74"> 74: </a>{
<a name="line75"> 75: </a>  static int fd = -1,dims[4],dim = 1,dof;
<a name="line76"> 76: </a>  char       filename[1024],buffer[1024];
<a name="line77"> 77: </a>  int        err,d2,d3,d4;
<a name="line78"> 78: </a>  FILE       *file;

<a name="line80"> 80: </a>  <font color="#B22222">/* check output parameters */</font>
<a name="line81"> 81: </a>  <font color="#4169E1">if</font> (nlhs != 1) PETSC_MEX_ERROR(<font color="#666666">"Receive requires one output argument."</font>);
<a name="line82"> 82: </a>  <font color="#4169E1">if</font> (fd == -1) {
<a name="line83"> 83: </a>    <font color="#4169E1">if</font> (!mxIsChar(prhs[0])) PETSC_MEX_ERROR(<font color="#666666">"First arg must be string."</font>);
<a name="line84"> 84: </a>
<a name="line85"> 85: </a>    <font color="#B22222">/* open the file */</font>
<a name="line86"> 86: </a>    mxGetString(prhs[0],filename,256);
<a name="line87"> 87: </a>    fd = open(filename,O_RDONLY,0);

<a name="line89"> 89: </a>    strcat(filename,<font color="#666666">".info"</font>);
<a name="line90"> 90: </a>    file = fopen(filename,<font color="#666666">"r"</font>);
<a name="line91"> 91: </a>    <font color="#4169E1">if</font> (file) {
<a name="line92"> 92: </a>      fgets(buffer,1024,file);
<a name="line93"> 93: </a>      <font color="#4169E1">if</font> (!strncmp(buffer,<font color="#666666">"-daload_info"</font>,12)) {
<a name="line94"> 94: </a>        sscanf(buffer,<font color="#666666">"-daload_info %d,%d,%d,%d,%d,%d,%d,%d\n"</font>,&amp;dim,&amp;dims[0],&amp;dims[1],&amp;dims[2],&amp;dof,&amp;d2,&amp;d3,&amp;d4);
<a name="line95"> 95: </a>        <font color="#4169E1">if</font> (dof &gt; 1) {
<a name="line96"> 96: </a>          dim++;
<a name="line97"> 97: </a>          dims[3] = dims[2];
<a name="line98"> 98: </a>          dims[2] = dims[1];
<a name="line99"> 99: </a>          dims[1] = dims[0];
<a name="line100">100: </a>          dims[0] = dof;
<a name="line101">101: </a>        }
<a name="line102">102: </a>      }
<a name="line103">103: </a>      fclose(file);
<a name="line104">104: </a>    }
<a name="line105">105: </a>  }

<a name="line107">107: </a>  <font color="#B22222">/* read in the next vector */</font>
<a name="line108">108: </a>  err = ReadInVecs(plhs,fd,dim,dims);

<a name="line110">110: </a>  <font color="#4169E1">if</font> (err) {  <font color="#B22222">/* file is finished so close and allow a restart */</font>
<a name="line111">111: </a>    close(fd);
<a name="line112">112: </a>    fd = -1;
<a name="line113">113: </a>  }
<a name="line114">114: </a>  <font color="#4169E1">return</font>;
<a name="line115">115: </a>}


<a name="line118">118: </a>
</pre>
</body>

</html>
